﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win;

namespace _128087
{
    public partial class Form1 : Form
    {
        DataSet ds = new DataSet();
        Infragistics.Win.Appearance app0 = new Infragistics.Win.Appearance();
        Infragistics.Win.Appearance app1 = new Infragistics.Win.Appearance();
        Infragistics.Win.Appearance app2 = new Infragistics.Win.Appearance();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            app0.BackColor = Color.White;
            app1.BackColor = Color.Green;
            app2.BackColor = Color.Red;

            DataTable t1 = ds.Tables.Add("Table1");
            DataTable t2 = ds.Tables.Add("Table2");

            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Text", typeof(string)).Expression = "'Text'+[id]";

            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("LAST", typeof(String));//.Expression = "'Text'+[id]+ [pid]";

            for (int i = 0; i < 5; i++)
            {
                DataRow row = t1.Rows.Add();
                for (int j = 0; j < 10; j++)
                {
                    t2.Rows.Add(null, row["id"]);
                }
            }


            ds.Relations.Add("ChildBand", t1.Columns["id"], t2.Columns["pid"]);

            ultraGridWatch.DataSource = ds;

            ultraGridWatch.InitializeRow += new InitializeRowEventHandler(ultraGridWatch_InitializeRow);
            ultraGrid1.InitializeRow += new InitializeRowEventHandler(ultraGrid1_InitializeRow);

        }

        void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (!e.ReInitialize)
            {
                UltraGridRow searchedRow = FindRow(ultraGridWatch, "id", e.Row.Cells["id"].Value);
                if (searchedRow != null)
                {
                    e.Row.CellAppearance = searchedRow.CellAppearance;
                    e.Row.Appearance = searchedRow.Appearance;
                }
            }
        }

        private UltraGridRow FindRow(UltraGrid grid, string colKey, object value)
        {
            foreach (UltraGridRow row in grid.Rows)
            {
                UltraGridRow sRow = row.ChildBands[0].Rows.FirstOrDefault(r => r.Cells[colKey].Value.Equals ( value));
                if (sRow != null)
                    return sRow;
            }
            return null;
        }

        void ultraGridWatch_InitializeRow(object sender, InitializeRowEventArgs e)
        {

            if (e.Row.Band.Key == "ChildBand" || e.Row.Band.Key == "Table2")
            {
                switch ((int)e.Row.Cells["id"].Value % 3)
                {
                    case 0:
                        e.Row.CellAppearance = app0;
                        break;
                    case 1:
                        e.Row.CellAppearance = app1;
                        break;
                    case 2:
                        e.Row.CellAppearance = app2;
                        break;
                }
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            DataTable t2 = ds.Tables["Table2"];
            DataView view = new DataView(t2);
            view.RowFilter = "LAST is Null";
 
            ultraGrid1.DataSource = view;
        }

        
    }
}
